#!/bin/sh

PATH=/bin:/sbin:/usr/bin:/usr/sbin

W_LOG=/tmp/Data/script.log
W_DIR=/tmp/self_upgrade

/usr/local/sony/bin/nblconfig -ksel normal

/bin/mount -o remount -t tmpfs -o size=51m /dev/shm /tmp

mkdir -p /tmp/Data
# /usr/local/sony/bin/mtdmount -t vfat -o rw,shortname=winnt,iocharset=utf8 Data /tmp/Data
/usr/local/sony/bin/mtdmount -t vfat -o utf8 -o shortname=winnt Data /tmp/Data

echo Starting $0 > $W_LOG

for file in /proc/filesystems /proc/mtd /proc/mounts
do
   echo "-----------------------------" >> $W_LOG
   echo $file >> $W_LOG
   cat $file >> $W_LOG
   echo "-----------------------------" >> $W_LOG
done

echo "df -k before remount" >> $W_LOG
echo "-----------------------------------" >> $W_LOG
/bin/df -k >> $W_LOG
echo "-----------------------------------" >> $W_LOG

#/bin/mount -o remount -t tmpfs -o size=32m /dev/shm /tmp >> $W_LOG 2>&1

#echo "df -k after remount" >> $W_LOG
#echo "-----------------------------------" >> $W_LOG
#/bin/df -k >> $W_LOG
#echo "-----------------------------------" >> $W_LOG

echo "/usr/local/sony/bin/nblconfig -dump" >> $W_LOG
echo "-----------------------------------" >> $W_LOG
/usr/local/sony/bin/nblconfig -dump >> $W_LOG
echo "-----------------------------------" >> $W_LOG

echo "/usr/local/sony/bin/nblsdm -?" >> $W_LOG
echo "-----------------------------------" >> $W_LOG
/usr/local/sony/bin/nblsdm -? >> $W_LOG
echo "-----------------------------------" >> $W_LOG
echo "/usr/local/sony/bin/nblsdm list" >> $W_LOG
echo "-----------------------------------" >> $W_LOG
/usr/local/sony/bin/nblsdm list >> $W_LOG
echo "-----------------------------------" >> $W_LOG


# Flashing the FS

mkdir -p $W_DIR

SD_IMG=/tmp/Data/test/new_opt.600.img
SD_MD5=/tmp/Data/test/new_opt.600.md5
TMP_IMG=$W_DIR/new_opt.600.img
TMP_MD5=$W_DIR/new_opt.600.md5

if [ -f $SD_IMG -a -f $SD_MD5 ]
then
   cp -f $SD_IMG $TMP_IMG
   cp -f $SD_MD5 $TMP_MD5
else
   sync
   sync
   sync
   reboot
   exit 0
fi

# Max Image Size
OPT_IMG_SIZE=18874368
OPT_IMG_DEV=0

echo -n "Begin flashing -> " >> $W_LOG
$date >> $W_LOG

if [ -f $TMP_IMG -a -f $TMP_MD5 ]
then
   # cp -f $SD_IMG $TMP_IMG
   REAL_MD5=`/usr/bin/md5sum $TMP_IMG | cut -f1 -d\  `
   TEST_MD5=`cut -f1 -d\  $TMP_MD5 `

   if [ $REAL_MD5 = $TEST_MD5 ]
   then
      echo "Checksum correct" >> $W_LOG
   else
      echo "MD5 check failure [$REAL_MD5 != $TEST_MD5]" >> $W_LOG
      exit 1
   fi
else
   echo "Image or md5 not found" >> $W_LOG
   exit 1
fi

echo "Checking cramfs image size ...." >> $W_LOG
NEW_IMG_SIZE=`$du -b $TMP_IMG | $cut -f 1`
echo "Cramfs image size: $NEW_IMG_SIZE" >> $W_LOG

if [ $NEW_IMG_SIZE -gt $OPT_IMG_SIZE ]; then
  echo "Opt image size is too big!" >> $W_LOG
  exit 1
fi

echo "Image size is OK" >> $W_LOG

/bin/df -k >> $W_LOG

# Flashing !!!

echo "Deleting previous Fsk partition..." >> $W_LOG
echo /usr/local/sony/bin/nblsdm delete Rootfs >> $W_LOG

if ! /usr/local/sony/bin/nblsdm delete Rootfs >> $W_LOG 2>&1; then
  echo "Warning: error deleting partition!" >> $W_LOG
fi

echo "Flashing Fsk partition with the new image..." >> $W_LOG
echo /usr/local/sony/bin/nblsdm create -d $OPT_IMG_DEV -l $OPT_IMG_SIZE -i $TMP_IMG Rootfs >> $W_LOG

if ! /usr/local/sony/bin/nblsdm create -d $OPT_IMG_DEV -l $OPT_IMG_SIZE -i $TMP_IMG Rootfs >> $W_LOG 2>&1; then
  /usr/local/sony/bin/nblconfig -ksel recovery
  echo "Error while flashing partition!" >> $W_LOG
  exit 1
fi

echo "Checking flashed partition against the image..." >> $W_LOG
echo /usr/local/sony/bin/nblsdm cmp -i $TMP_IMG Rootfs >> $W_LOG

if ! /usr/local/sony/bin/nblsdm cmp -i $TMP_IMG Rootfs >> $W_LOG 2>&1; then
  /usr/local/sony/bin/nblconfig -ksel recovery
  echo "Partition check failed!" >> $W_LOG
  exit 1
fi

echo "Remove the files from Data..." >> $W_LOG

rm -rf /tmp/Data/test

echo "Reflashing was successful. Rebooting..." >> $W_LOG

sync
sync
sync
reboot
exit 0

